<?php
/**************************************************
  Coppermine 1.5.x Plugin - email_comments
**************************************************/

/* Configuration variables
      'plugin_email_comments_version'
      'plugin_email_comments_send_owner'
      'plugin_email_comments_send_commenters'
      'plugin_email_comments_send_thumbnail'
      'plugin_email_comments_subject'
      'plugin_email_comments_owner'
      'plugin_email_comments_author'
      'plugin_email_comments_text1'
      'plugin_email_comments_text2'
      'plugin_email_comments_text3'
      'plugin_email_comments_text4'
      'plugin_email_comments_loginreq'
*/


// create Inspekt supercage
$superCage = Inspekt::makeSuperCage();

// Make sure that this file can't be accessed directly, but only from within the Coppermine user interface
if (!defined('IN_COPPERMINE')) {
    die('Not in Coppermine...');
}

if (!GALLERY_ADMIN_MODE) {
    cpg_die(ERROR, $lang_errors['access_denied'], __FILE__, __LINE__);
}

//include_once('functions.php');                                                  // include plugin subfunctions
// get language files
require "./plugins/email_comments/lang/english.php";
if ($CONFIG['lang'] != 'english' && file_exists("./plugins/email_comments/lang/{$CONFIG['lang']}.php")) {
    require "./plugins/email_comments/lang/{$CONFIG['lang']}.php";
}

// get sanitized POST parameters
if (($superCage->post->keyExists('submit')) && ($superCage->post->getRaw('submit') == $lang_plugin_email_comments['submit'])) {
    //Check if the form token is valid
    if(!checkFormToken()){
        cpg_die(ERROR, $lang_errors['invalid_form_token'], __FILE__, __LINE__);
    }

  // Define the sanitization patterns
  $sanitization_array = array(
      'plugin_email_comments_send_owner' => array('type' => 'checkbox', 'min' => '0', 'max' => '1'),                            // checkbox - yes|no
      'plugin_email_comments_send_commenters' => array('type' => 'checkbox', 'min' => '0', 'max' => '1'),                       // checkbox - yes|no
      'plugin_email_comments_send_thumbnail' => array('type' => 'checkbox', 'min' => '0', 'max' => '1'),                        // checkbox - yes|no
      'plugin_email_comments_subject'  => array('type' => 'raw', 'regex' => '/([^n]*+[^V\.]++)*+/'),                            // text - A-Z a-z - _ . /
      'plugin_email_comments_owner'  => array('type' => 'raw', 'regex' => '/([^n]*+[^V\.]++)*+/'),                              // text - A-Z a-z - _ . /
      'plugin_email_comments_author'  => array('type' => 'raw', 'regex' => '/([^n]*+[^V\.]++)*+/'),                             // text - A-Z a-z - _ . /
      'plugin_email_comments_text1'  => array('type' => 'raw', 'regex' => '/([^n]*+[^V\.]++)*+/'),                              // text - A-Z a-z - _ . /
      'plugin_email_comments_text2'  => array('type' => 'raw', 'regex' => '/([^n]*+[^V\.]++)*+/'),                              // text - A-Z a-z - _ . /
      'plugin_email_comments_text3'  => array('type' => 'raw', 'regex' => '/([^n]*+[^V\.]++)*+/'),                              // text - A-Z a-z - _ . /
      'plugin_email_comments_text4'  => array('type' => 'raw', 'regex' => '/([^n]*+[^V\.]++)*+/'),                              // text - A-Z a-z - _ . /
      'plugin_email_comments_loginreq'  => array('type' => 'raw', 'regex' => '/([^n]*+[^V\.]++)*+/'),                           // text - A-Z a-z - _ . /
  );
  $config_changes_counter = 0;
  $plugin_email_comments_execute = FALSE;
  $plugin_email_comments_execute_files = FALSE;
  foreach ($sanitization_array as $san_key => $san_value) {
      if (isset($CONFIG[$san_key]) == TRUE) { // only loop if config value is set --- start
          if ($san_value['type'] == 'checkbox') { // type is checkbox --- start
            if ($superCage->post->getInt($san_key) <= $san_value['max'] && $superCage->post->getInt($san_key) >= $san_value['min'] && $superCage->post->getInt($san_key) != $CONFIG[$san_key]) {   // **GMC
                $CONFIG[$san_key] = $superCage->post->getInt($san_key);
                cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$san_key]}' WHERE name='$san_key'");
                $config_changes_counter++;
            } elseif($superCage->post->keyExists($san_key) != TRUE && $CONFIG[$san_key] != '0') {
                $CONFIG[$san_key] = 0;
                cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$san_key]}' WHERE name='$san_key'");
                $config_changes_counter++;
            }
          } // type is checkbox --- end
          if ($san_value['type'] == 'int') { // type is integer --- start
              if ($superCage->post->getInt($san_key) <= $san_value['max'] && $superCage->post->getInt($san_key) >= $san_value['min'] && $superCage->post->getInt($san_key) != $CONFIG[$san_key]) {
                  $CONFIG[$san_key] = $superCage->post->getInt($san_key);
                  cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$san_key]}' WHERE name='$san_key'");
                  $config_changes_counter++;
              }
          } // type is integer --- end
          if ($san_value['type'] == 'raw') { // type is raw --- start
              // added code to:
              // - retain current value if variable is not passed in form (some raw elements set to disabled - so not passed in form input..)
              // - trim whitespace from beginning/end of string
              if($superCage->post->keyExists($san_key) == TRUE) {
                // only if variable was passed in form
                $trim_var = trim($superCage->post->getRaw($san_key));             // pull in var from superCage and trim whitespace
                if (isset($san_value['regex']) == TRUE && preg_match($san_value['regex'], $trim_var) && $trim_var != $CONFIG[$san_key]) {
                  $CONFIG[$san_key] = $trim_var;
                  if ($trim_var == 'none') {
                    $CONFIG[$san_key] = '';
                  }
                  cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$san_key]}' WHERE name='$san_key'");
                  $config_changes_counter++;
                }
              }
          } // type is raw --- end
          if ($san_value['type'] == 'array') { // type is array --- start              
          $evaluate_value = $superCage->post->getRaw($san_key);
              if (is_array($evaluate_value) && isset($san_value['regex']) == TRUE && isset($san_value['delimiter']) == TRUE) {
                  $temp = '';
                  for ($i = 0; $i <= count($evaluate_value); $i++) {
                      if (preg_match($san_value['regex'], $evaluate_value[$i])) {
                          $temp .= $evaluate_value[$i] . $san_value['delimiter'];
                      }
                  }
                  unset($evaluate_value);
                  $evaluate_value = rtrim($temp, $san_value['delimiter']);
                  unset($temp);
              }
              if ($evaluate_value != $CONFIG[$san_key]) {
                  $CONFIG[$san_key] = $evaluate_value;
                  cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$san_key]}' WHERE name='$san_key'");
                  $config_changes_counter++;
              }
          } // type is array --- end
      } // only loop if config value is set --- end
  }
}


// display config page

// Set the option output stuff
if ($CONFIG['plugin_email_comments_adminmode'] == '1') {
    $option_output['plugin_email_comments_adminmode'] = 'checked="checked"';
} else { 
    $option_output['plugin_email_comments_adminmode'] = '';
}

if ($CONFIG['plugin_email_comments_send_owner'] == '1') {
    $option_output['plugin_email_comments_send_owner'] = 'checked="checked"';
} else { 
    $option_output['plugin_email_comments_send_owner'] = '';
}

if ($CONFIG['plugin_email_comments_send_commenters'] == '1') {
    $option_output['plugin_email_comments_send_commenters'] = 'checked="checked"';
} else { 
    $option_output['plugin_email_comments_send_commenters'] = '';
}

if ($CONFIG['plugin_email_comments_send_thumbnail'] == '1') {
    $option_output['plugin_email_comments_send_thumbnail'] = 'checked="checked"';
} else { 
    $option_output['plugin_email_comments_send_thumbnail'] = '';
}

pageheader(sprintf("{$lang_plugin_email_comments['configure_x']} V{$CONFIG['plugin_email_comments_version']}", $lang_plugin_email_comments['plugin_name']));
list($timestamp, $form_token) = getFormToken();
echo <<< EOT
<form action="index.php?file=email_comments/admin" method="post" name="email_comments_settings">
EOT;
starttable('100%', sprintf("{$lang_plugin_email_comments['configure_x']} V{$CONFIG['plugin_email_comments_version']}", $lang_plugin_email_comments['plugin_name']), 3, 'cpg_zebra');

// add condition to be sure the submit button was for config updates before displaying messagebox
if ($superCage->post->keyExists('submit') && $superCage->post->getRaw('submit') == $lang_plugin_email_comments['submit']) {
    if ($config_changes_counter > 0) {
        echo <<< EOT
    <tr>
        <td class="tablef" colspan="2" >
EOT;
        msg_box('', $lang_plugin_email_comments['update_success'], '', '', 'success');
    } else {
        msg_box('', $lang_plugin_email_comments['no_changes'], '', '', 'validation');
    }
        echo <<< EOT
        </td>
    </tr>
EOT;
}

echo <<< EOT
  <!-- insert config option form code start -->

    <tr>                                                                                                                               
      <td class="tableb" colspan="2">
        <span class="detail_head_collapsed">
          Show / Hide Plugin Settings
        </span>
        <div id="section0" class="detail_body">
          <table align="center" width="100%" cellspacing="1" cellpadding="0" class="maintable" border="0">
            <tr>
              <td>
                &nbsp;
              </td>                                                                                                                            
            </tr>                                                                                                                              

            <tr>
              <td>
                <label for="plugin_email_comments_send_owner" class="clickable_option">{$lang_plugin_email_comments['send_owner']}</label>
              </td>
              <td>
                <input type="checkbox" name="plugin_email_comments_send_owner" id="plugin_email_comments_send_owner" class="checkbox" value="1" {$option_output['plugin_email_comments_send_owner']} />
                <label for="plugin_email_comments_send_owner" class="clickable_option">{$lang_common['yes']}</label>
              </td>
            </tr>

            <tr>
              <td>
                <label for="plugin_email_comments_send_commenters" class="clickable_option">{$lang_plugin_email_comments['send_commenters']}</label>
              </td>
              <td>
                <input type="checkbox" name="plugin_email_comments_send_commenters" id="plugin_email_comments_send_commenters" class="checkbox" value="1" {$option_output['plugin_email_comments_send_commenters']} />
                <label for="plugin_email_comments_send_commenters" class="clickable_option">{$lang_common['yes']}</label>)
              </td>
            </tr>

            <tr>
              <td>
                <label for="plugin_email_comments_send_thumbnail" class="clickable_option">{$lang_plugin_email_comments['send_thumbnail']}</label>
              </td>
              <td>
                <input type="checkbox" name="plugin_email_comments_send_thumbnail" id="plugin_email_comments_send_thumbnail" class="checkbox" value="1" {$option_output['plugin_email_comments_send_thumbnail']} />
                <label for="plugin_email_comments_send_thumbnail" class="clickable_option">{$lang_common['yes']}</label>
              </td>
            </tr>

            <tr>
              <td valign="top">
                {$lang_plugin_email_comments['subject']}
              </td>
              <td>
                <input type="text" name="plugin_email_comments_subject" id="plugin_email_comments_subject" class="textinput" size="75" maxlength="255" value="{$CONFIG['plugin_email_comments_subject']}" {$option_output['plugin_email_comments_subject']} /> {$lang_plugin_email_comments['subject_comment']}
              </td>
            </tr>
            <tr>
              <td valign="top">
                {$lang_plugin_email_comments['owner']}
              </td>
              <td>
                <input type="text" name="plugin_email_comments_owner" id="plugin_email_comments_owner" class="textinput" size="75" maxlength="255" value="{$CONFIG['plugin_email_comments_owner']}" {$option_output['plugin_email_comments_owner']} /> {$lang_plugin_email_comments['owner_comment']}
              </td>
            </tr>
            <tr>
              <td valign="top">
                {$lang_plugin_email_comments['author']}
              </td>
              <td>
                <input type="text" name="plugin_email_comments_author" id="plugin_email_comments_author" class="textinput" size="75" maxlength="255" value="{$CONFIG['plugin_email_comments_author']}" {$option_output['plugin_email_comments_author']} /> {$lang_plugin_email_comments['author_comment']}
              </td>
            </tr>
            <tr>
              <td valign="top">
                &nbsp;
              </td>
              <td>
                {$lang_plugin_email_comments['title_thumb']}
              </td>
            </tr>
            <tr>
              <td valign="top">
                {$lang_plugin_email_comments['text1']}
              </td>
              <td>
                <input type="text" name="plugin_email_comments_text1" id="plugin_email_comments_text1" class="textinput" size="75" maxlength="255" value="{$CONFIG['plugin_email_comments_text1']}" {$option_output['plugin_email_comments_text1']} /> {$lang_plugin_email_comments['text1_comment']}
              </td>
            </tr>
            <tr>
              <td valign="top">
                {$lang_plugin_email_comments['text2']}
              </td>
              <td>
                <input type="text" name="plugin_email_comments_text2" id="plugin_email_comments_text2" class="textinput" size="75" maxlength="255" value="{$CONFIG['plugin_email_comments_text2']}" {$option_output['plugin_email_comments_text2']} /> {$lang_plugin_email_comments['text2_comment']}
              </td>
            </tr>
            <tr>
              <td valign="top">
                {$lang_plugin_email_comments['text3']}
              </td>
              <td>
                <input type="text" name="plugin_email_comments_text3" id="plugin_email_comments_text3" class="textinput" size="75" maxlength="255" value="{$CONFIG['plugin_email_comments_text3']}" {$option_output['plugin_email_comments_text3']} /> {$lang_plugin_email_comments['text3_comment']}
              </td>
            </tr>
            <tr>
              <td valign="top">
                {$lang_plugin_email_comments['text4']}
              </td>
              <td>
                <input type="text" name="plugin_email_comments_text4" id="plugin_email_comments_text4" class="textinput" size="75" maxlength="255" value="{$CONFIG['plugin_email_comments_text4']}" {$option_output['plugin_email_comments_text4']} /> {$lang_plugin_email_comments['text4_comment']}
              </td>
            </tr>
            <tr>
              <td valign="top">
                {$lang_plugin_email_comments['loginreq']}
              </td>
              <td>
                <input type="text" name="plugin_email_comments_loginreq" id="plugin_email_comments_loginreq" class="textinput" size="75" maxlength="255" value="{$CONFIG['plugin_email_comments_loginreq']}" {$option_output['plugin_email_comments_loginreq']} /> {$lang_plugin_email_comments['loginreq_comment']}
              </td>
            </tr>

          </table>
        </div>
      </td>
    </tr>

    <!-- insert config option form code end -->
    <tr>
        <td class="tablef" colspan="3">
            <input type="hidden" name="form_token" value="{$form_token}" />
            <input type="hidden" name="timestamp" value="{$timestamp}" />
            <button type="submit" class="button" name="submit" value="{$lang_plugin_email_comments['submit']}">{$lang_plugin_email_comments['submit']}</button>
        </td>
    </tr>
EOT;

endtable();

// get sanitized POST parameters
if ($superCage->post->keyExists('submit')) {
    //Check if the form token is valid
    if(!checkFormToken()){
        cpg_die(ERROR, $lang_errors['invalid_form_token'], __FILE__, __LINE__);
    }
    // documentation options
    $plugin_email_comments_doc_readme = ($superCage->post->getRaw('submit') == $lang_plugin_email_comments['view_readme']) ? TRUE : FALSE;   // See if we are showing doc...
    if ($plugin_email_comments_doc_readme) {
      include ('./plugins/email_comments/readme.php');
    }
}

starttable('100%', sprintf("{$lang_plugin_email_comments['execute_x']} V{$CONFIG['plugin_email_comments_version']}", $lang_plugin_email_comments['plugin_name']), 3, 'cpg_zebra');

// sample emails - some logic from codebase repeated here... possible future consolidation into function
require_once ('include/smilies.inc.php');
// get last gallery comment
$result = cpg_db_query("SELECT pid, msg_id, msg_author, msg_body, author_id FROM {$CONFIG['TABLE_COMMENTS']} ORDER BY msg_id DESC LIMIT 1");
$commentrow = cpg_db_fetch_row($result);
mysql_free_result($result);
if ($commentrow) {
  $condition = "WHERE pid = '{$commentrow['pid']}'";
} else {
  // no comment found - set up sample data
  $commentrow = array('msg_author' => 'author', 'msg_body' => 'Sample comment text');
  $condition = "ORDER BY pid DESC";
}
$result = cpg_db_query("SELECT pid, url_prefix, filepath, filename, owner_id, title, caption, pwidth, pheight FROM {$CONFIG['TABLE_PICTURES']} $condition LIMIT 1");
$picture = cpg_db_fetch_row($result);
mysql_free_result($result);
// extract title, link to picture, comment text (pic_markup set above already...)
$title = $picture['title'] ? $picture['title'] : $picture['filename'];
$link = $CONFIG['ecards_more_pic_target'] . (substr($CONFIG["ecards_more_pic_target"], -1) == '/' ? '' : '/') . 'displayimage.php?pid='.$picture['pid'];
$author = $commentrow['msg_author'];
$comment = '"' . bb_decode(process_smilies($commentrow['msg_body'], $CONFIG['ecards_more_pic_target'])) . '"';
// construct thumbnail info if requested
if ($CONFIG['plugin_email_comments_send_thumbnail']) {
  // get url for thumbnail to include
  $thumb_pic_url = get_pic_url($picture, 'thumb');
  $gallery_url_prefix = $CONFIG['ecards_more_pic_target']. (substr($CONFIG['ecards_more_pic_target'], -1) == '/' ? '' : '/');
  if (!stristr($thumb_pic_url, 'http:')) {
    $thumb_pic_url = $gallery_url_prefix . $thumb_pic_url;
  }
  $pic_markup = '<img src="'.$thumb_pic_url.'" alt="CPG Thumbnail" vspace="8" border="0" class="image" /><br />';
} else {
  $pic_markup = '';
}
// build email message from CONFIG settings and variables
$mail_owner = $CONFIG['plugin_email_comments_owner'].': <br />';                // prefix for owner email
$mail_author = $CONFIG['plugin_email_comments_author'].': <br />';              // prefix for comment author emails
$mail_message = email_comments_build_email($title, $pic_markup, $author, $comment, $link);
// get email addresses and usernames for owner (actual code gets all commenters)
$result = cpg_db_query("SELECT ".$cpg_udb->field['email']." AS user_email, ".$cpg_udb->field['user_id']." AS user_id, ".$cpg_udb->field['username']." AS username  FROM ".$cpg_udb->usertable." WHERE ".$cpg_udb->field['user_id']." = '".$picture['owner_id']."' LIMIT 1");
$row = cpg_db_fetch_row($result);
$mail_body_owner = make_clickable($mail_owner . $mail_message);
$mail_body_author = make_clickable($mail_author . $mail_message);
$search  = array('{username}');
$replace = array($row['username']);
$replace2 = 'username';
$mail_body_owner = str_replace($search, $replace, $mail_body_owner);
$mail_body_author = str_replace($search, $replace2, $mail_body_author);
// email to owner
echo <<< EOT
    <tr>
      <td valign="top">
        {$lang_plugin_email_comments['sample_owner']}
      </td>
      <td>
        {$lang_plugin_email_comments['subject']}: {$CONFIG['gallery_name']}: {$CONFIG['plugin_email_comments_subject']}<br />
        {$lang_plugin_email_comments['body']}:<br />
        $mail_body_owner
      </td>
    </tr>
EOT;
// email to commenters (if requested in config...)
if ($CONFIG['plugin_email_comments_send_commenters']) {
  echo <<< EOT
    <tr>
      <td valign="top">
        {$lang_plugin_email_comments['sample_author']}
      </td>
      <td>
        {$lang_plugin_email_comments['subject']}: {$CONFIG['gallery_name']}: {$CONFIG['plugin_email_comments_subject']}<br />
        {$lang_plugin_email_comments['body']}:<br />
        $mail_body_author
      </td>
    </tr>
EOT;
}
// documentation options
echo <<< EOT
    <tr>                                
        <td class="tablef" colspan="3"> 
            &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Documentation: &nbsp;&nbsp;
            <button type="submit" class="button" name="submit" value="{$lang_plugin_email_comments['view_readme']}" >{$lang_plugin_email_comments['view_readme']}</button>
        </td>
    </tr>
EOT;
endtable();

echo <<< EOT
</form>
EOT;
pagefooter();

?>