<?php
/**************************************************
  Coppermine 1.5.x Plugin - gallery_merge
**************************************************/

if (!defined('IN_COPPERMINE')) {
  // allow direct display - add necessary html
  echo <<< EOT
  <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
  <html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en" dir="ltr">
    <head>
        <title>Email Comments Readme</title>
        <link rel="stylesheet" href="../../css/coppermine.css" type="text/css" />
        <link rel="stylesheet" href="../../themes/curve/style.css" type="text/css" />
        <script src="docs/js/jquery.js" type="text/javascript"></script>
        <script src="docs/js/help.js" type="text/javascript"></script>
    </head>
    <body>
        <div id="cpg_main_block">
          <p>&nbsp;<p>
          <table align="center" width="100%" cellspacing="1" cellpadding="0" class="maintable cpg_zebra">
            <tr>
                <td class="" colspan="3">
                    <div class="cpg_starttable_outer">
                        <div class="cpg_starttable_inner">
                            View Documentation
                        </div>
                    </div>
                </td>
            </tr>
EOT;
}

echo <<< EOT
  <tr>
    <td colspan=3>
      <h2>
      Email Comments:
      </h2>
    </td>
  </tr>
  <tr>
    <td>
This plugin adds the  ability to email comments left for a photo to the owner - and optionally to others that have left comments for the same photo.
It is based on information in <a href="http://forum.coppermine-gallery.net/index.php/topic,71072.0.html" target="_new">this forum thread</a> including
input from Andr, lurkalot, and cmfa.
<p>

CONFIGURATION settings allow specification of whether to email owner only, email others that have left comments,
whether to include a thumbnail of the image in the email, email subject and email text to use.
Sample emails are shown to reflect the current settings.
<p>

    </td>
  </tr>
  <tr>
    <td colspan=3>
      <p>&nbsp;<p>
      <h2>
      Installation:
      </h2>
    </td>
  </tr>
  <tr>
    <td>

Unzip the distribution files and upload the contents (including folder comment_email) to your plugins directory.
In admin mode, select Plugin Manager, and click install next to this plugin.
<p>
    </td>
  </tr>
  <tr>
    <td colspan=3>
      <p>&nbsp;<p>
      <h2>
      Uninstall:
      </h2>
    </td>
  </tr>
  <tr>
    <td>

Select Plugin Manager, and click uninstall next to this plugin.<br>
The normal plugin manager confirmation will be displayed first - Click 'OK'<br>
A confirmation dialog will be presented by Comment Email to allow you to select desired actions.<br>
You can of course select any/all items to be removed.<br>
Click 'Uninstall Comment Email' to proceed.

    </td>
  </tr>
  <tr>
    <td colspan=3>
      <p>&nbsp;<p>
      <h2>
      Configuration:
      </h2>
    </td>
  </tr>
  <tr>
    <td>

Select configure on this plugin from Plugin Manager.<br>
The Configuration Settings are hidden by default. Click 'show' to expand (much like CPG configuration).
Select appropriate check boxes, based on preferences.
EOT;

if (!defined('IN_COPPERMINE')) {
  // for direct display - add image of config screen
  echo <<< EOT
  <p><img src='readme_config.png' alt='config menu'>
EOT;
}

echo <<< EOT
<p>
Setting Descriptions:
<ul>
  <li>Send Comment Emails to Photo Owner<br>
    When checked enables plugin and sends email to photo owner. Unchecking this option disables the plugin.</li>
  <li>Send Comment Emails to Other Commenters<br>
    In addition to the owner, send an email to any others that have left comments for the same photo.</li>
  <li>Send Thumbnail Image in Email<br>
    When checked, include an embedded image of the photo thumbnail in the email.</li>
  <li>Email Subject<br>
    Text Subject to use for email. The gallery name is placed in front of this text.</li>
</ul>
<p>
For the Owner, Author, and Email Paragraphs below, there is a 255 character limit each.<br />
The following tokens can be used in any of these entries and will be replaced when sending:
<ul>
  <li>{username} - the username of the email recipient</li>
</ul>
<p>&nbsp;<br />
Setting Descriptions (continued):
<ul>
  <li>Email Intro to Owner<br>
    Text to start the email body to picture owner.</li>
  <li>Email Intro to Comment Authors<br>
    Text to start the email body to others that have commented on the photo.</li>
</ul>
<p>
The photo title (or filename if no title) and thumbnail (if requested) inserted following this.
The following additional tokens can be used in the following entries and will be replaced when sending:
<ul>
  <li>{author} - the username of the comment author</li>
  <li>{comment} - the text of the comment left</li>
  <li>{link} - link to this photo in the gallery</li>
</ul>
<p>&nbsp;<br />
Setting Descriptions (continued):
<ul>
  <li>Email Paragraph 1<br>
    First paragraph of text for email body (follows title and thumbnail)</li>
  <li>Email Paragraph 2<br>
    Second paragraph of text for email body</li>
  <li>Email Paragraph 3<br>
    Third paragraph of text for email body</li>
  <li>Email Paragraph 4<br>
    Fourth paragraph of text for email body</li>
  <li>Email Login Required<br>
    Additional paragraph of text for email body added when gallery is set to require login to view pictures.</li>
<ul>
<p>&nbsp;<br />
Once submitted, validated, your settings will be saved, and the configuration screen redisplayed with results.<br>
The text of a sample email using one of your gallery photos will be shown as would be sent to the photo owner.
If email to other commenters is selected, a second email will be shown as would be sent to them.
    </td>
  </tr>
  <tr>
    <td colspan=3>
      <p>&nbsp;<p>
      <h2>
      Execution:
      </h2>
    </td>
  </tr>
  <tr>
    <td>

Plugin will be invoked (assuming Plugin API is active) anytime a comment is left (if no approval needed) - or when a
comment is approved. Emails will be sent per your setting - one email per recipient.<br>

    </td>
  </tr>
  <tr>
    <td colspan=3>
      <p>&nbsp;<p>
    </td>
  </tr>
  <tr>
    <td>

Your comments are welcome.<br>
I hope you find this useful.<br>
Greg (gmc on the CPG forum)

    </td>
  </tr>
EOT;

if (!defined('IN_COPPERMINE')) {
  // allow direct display - add necessary html
  echo <<< EOT
          </table>
       </div>
    </body>
  </html>
EOT;
}
?>